package com.jeeplus.test.reimbursementAccountant.domain.dto;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.sys.service.dto.UserDTO;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotNull;

/**
 * 报销人员表
 * @author: 徐滕
 * @version: 2022-05-16 11:06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("zs_reimbursement_user_info")
public class AccountantReimbursementUserDTO extends BaseEntity {

    @Excel(name = "姓名")
    @Length(min = 1, max = 100)
    @NotNull(message = "姓名不能为空")
    private String userName;//员工姓名
    @Excel(name = "部门")
    @Length(min = 1, max = 100)
    @NotNull(message = "部门不能为空")
    private String officeName;//部门名称

    private String userId;  //报销人id
    private UserDTO user;   //报销人员信息

    @Excel(name = "报销年份")
    @Length(min = 1, max = 100)
    @NotNull(message = "报销年份不能为空")
    private String year;    //报销年份
    @Excel(name = "年报销额度")
    @Length(min = 1, max = 100)
    @NotNull(message = "年报销额度不能为空")
    private String reimbursementQuota;  //年报销额度

    @Excel(name = "年可报销天数")
    @NotNull(message = "年可报销天数不能为空")
    private Integer reimbursementAllDay;  //年可报销天数
    @Excel(name = "日报销额度")
    @Length(min = 1, max = 100)
    @NotNull(message = "日报销额度不能为空")
    private String reimbursementQuotaDay;  //日报销额度
    private String reimbursementDay;  //报销天数
    private String reimbursementAmount;  //报销额度
    private String remainReimbursementAmount;  //剩余报销额度
    private String alreadyReimbursementAmount;  //已报销额度
    private String remarks; //备注


    private String alreadyReimbursementDay;  //已报销天数
    private String surplusReimbursementDay;  //剩余报销天数
    private String surplusReimbursementAmount;  //剩余报销额度
    private String keyFlag; //用于判断使用


}
