package com.jeeplus.test.reimbursementAccountant.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementBusinessDTO;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementBusinessReturnDTO;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementDTO;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementUserDTO;
import com.jeeplus.test.reimbursementsys.domain.dto.ReimbursementBusinessDTO;
import com.jeeplus.test.reimbursementsys.domain.dto.ReimbursementBusinessReturnDTO;
import com.jeeplus.test.reimbursementsys.domain.dto.ReimbursementDTO;
import com.jeeplus.test.reimbursementsys.domain.dto.ReimbursementUserDTO;

import java.util.List;
import java.util.Map;

/**
 * @author li-peike
 * @version 1.0.0
 * @ClassName ReimbursementSysService.java
 * @Description TODO
 * @createTime 2022年05月06日 10:25:00
 */

public interface AccountantReimbursementBusinessService {
    /**
     * 查询报销人员信息
     * @param id
     * @return
     */
    AccountantReimbursementBusinessDTO queryById(String id);
    /**
     * 查询业务报销额度相关信息
     * @param id
     * @return
     */
    AccountantReimbursementDTO getBusinessById(String id);
    /**
     * 查询报销信息(根据人员id和年份)
     * @param reimbursementUser
     * @return
     */
    AccountantReimbursementUserDTO queryByUserIdAndYear(AccountantReimbursementBusinessDTO reimbursementUser);

    /**
     * 查询列表信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<AccountantReimbursementUserDTO> findList(Page<AccountantReimbursementUserDTO> page, AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 根据人员信息查询报销年份信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<AccountantReimbursementUserDTO> getYearList(Page<AccountantReimbursementUserDTO> page, AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 保存报销数据信息
     * @param reimbursementUser
     */
    Map<String,Object> save(AccountantReimbursementBusinessDTO reimbursementUser);

    /**
     * 修改报销人员信息
     * @param reimbursementUser
     */
    void update(AccountantReimbursementBusinessDTO reimbursementUser);

    /**
     * 根据id删除人员报销信息（物理删除）
     * @param idList
     */
    void delete(List<String> idList);

    /**
     * 查询列表信息
     * @param reimbursementBusiness
     * @return
     */
    AccountantReimbursementBusinessReturnDTO findListByBusinessCodeId(AccountantReimbursementBusinessDTO reimbursementBusiness);
}
