package com.jeeplus.test.reimbursementAccountant.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.sys.service.dto.UserDTO;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementBusinessReturnDTO;
import com.jeeplus.test.reimbursementAccountant.domain.dto.AccountantReimbursementUserDTO;

import java.util.List;
import java.util.Map;

/**
 * @author li-peike
 * @version 1.0.0
 * @ClassName ReimbursementSysService.java
 * @Description TODO
 * @createTime 2022年05月06日 10:25:00
 */

public interface AccountantReimbursementUserService {
    /**
     * 查询报销人员信息
     * @param id
     * @return
     */
    AccountantReimbursementUserDTO queryById(String id);
    /**
     * 查询报销信息(根据人员id和年份)
     * @param reimbursementUser
     * @return
     */
    AccountantReimbursementUserDTO queryByUserIdAndYear(AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 查询列表信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<AccountantReimbursementUserDTO> findList(Page<AccountantReimbursementUserDTO> page, AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 保存方法
     * @param reimbursementUser
     */
    Map<String,Object> save(AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 修改报销人员信息
     * @param reimbursementUser
     */
    void update(AccountantReimbursementUserDTO reimbursementUser);

    /**
     * 根据id删除人员报销信息（物理删除）
     * @param idList
     */
    Map<String,Object> delete(List<String> idList);

    /**
     * 查询人员报销信息列表
     * @param reimbursementUserDTO
     * @return
     */
    AccountantReimbursementBusinessReturnDTO findListByUserId(AccountantReimbursementUserDTO reimbursementUserDTO);

    /**
     * 根据部门和人员名称查询人员信息
     * @param reimbursementUserDTO
     * @return
     */
    List<UserDTO> getUserByNameAndOfficeName(AccountantReimbursementUserDTO reimbursementUserDTO);


    /**
     * 保存方法(批量导入)
     * @param reimbursementUserList
     */
    Map<String,Object> saveList(List<AccountantReimbursementUserDTO> reimbursementUserList);
}
