package com.jeeplus.test.reimbursementsys.domain.dto;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.TreeEntity;
import com.jeeplus.sys.utils.StringUtils;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 中审报表数据表
 * @author: 徐滕
 * @version: 2022-05-11 10:31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("zs_reimbursement_info")
public class ReimbursementDTO extends TreeEntity<ReimbursementDTO> {
    private static final long serialVersionUID = 1L;
    @Excel(name = "业务编号")
    private String businessCode;    //业务编号
    private String businessCodeId;    //业务编号id
    @Excel(name = "发票代码")
    private String invoiceCode;     //发票代码
    @Excel(name = "发票号码")
    private String invoiceNumber;   //发票号码
    @Excel(name = "购方企业名称")
    private String firmName;        //购方企业名称

    @DateTimeFormat(pattern =  "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @Excel(name = "开票日期")
    private Date makeTime;          //开票日期
    @Excel(name = "商品名称")
    private String name;     //商品名称
    @Excel(name = "金额")
    private String money;       //金额
    @Excel(name = "税额")
    private String tax;         //税额
    @Excel(name = "收入")
    private String income;      //收入
    @Excel(name = "申请人")
    private String proposer;        //申请人
    @Excel(name = "合伙人")
    private String partner;         //合伙人
    @Excel(name = "业务类型")
    private String businessType;    //业务类型
    private String remarks;    //备注
    private Integer type;    //状态
    private String reimbursementRatio;    //报销比例
    private String allAlreadyReimbursementQuota;    //总报销额度（已报金额）
    private String canReimbursementAmount;    //可报销额度
    private String surplusReimbursementAmount;    //剩余报销额度
    private String reimbursementType;    //报销比例
    private String gatheringStatus;    //收款状态
    private String reimbursementStatus;    //报销状态
    private List<String> idList;

    @DateTimeFormat(pattern =  "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date gatheringTime;     //收款日期


    public String getReimbursementType() {
        if(StringUtils.isBlank(this.reimbursementType)){
            this.reimbursementType = "1";
        }
        return reimbursementType;
    }
}
