package com.jeeplus.test.reimbursementsys.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.sys.service.dto.UserDTO;
import com.jeeplus.test.reimbursementsys.domain.dto.ReimbursementUserDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author li-peike
 * @version 1.0.0
 * @ClassName ReimbursementSysMapper.java
 * @Description TODO
 * @createTime 2022年05月06日 10:40:00
 */
public interface ReimbursementUserMapper extends BaseMapper<ReimbursementUserDTO> {
    /**
     * 根据条件查询数据信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ReimbursementUserDTO> findList(Page<ReimbursementUserDTO> page, @Param("reimbursementUser")ReimbursementUserDTO reimbursementUser);
    /**
     * 根据条件查询数据信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ReimbursementUserDTO> getYearList(Page<ReimbursementUserDTO> page, @Param("reimbursementUser")ReimbursementUserDTO reimbursementUser);

    /**
     * 保存人员报销信息
     * @param reimbursementUser
     */
    void save(ReimbursementUserDTO reimbursementUser);

    /**
     * 保存人员报销信息
     * @param reimbursementUserList
     */
    void saveList(@Param("reimbursementUserList")List<ReimbursementUserDTO> reimbursementUserList);

    /**
     * 修改人员报销信息
     * @param reimbursementUser
     */
    void update(ReimbursementUserDTO reimbursementUser);

    /**
     * 查询业务信息
     * @param id
     * @return
     */
    ReimbursementUserDTO queryById(String id);

    /**
     * 查询报销信息(根据人员id和年份)
     * @param reimbursementUser
     * @return
     */
    ReimbursementUserDTO queryByUserIdAndYear(ReimbursementUserDTO reimbursementUser);

    /**
     * 根据id删除人员报销信息（物理删除）
     * @param idList
     */
    void delete(@Param("idList") List<String> idList);

    /**
     * 根据部门和人员名称查询人员信息
     * @param reimbursementUserDTO
     * @return
     */
    List<UserDTO> getUserByNameAndOfficeName(ReimbursementUserDTO reimbursementUserDTO);

}
